

if {![info exists ::AIDA::FEE64]} {variable ::AIDA::FEE64; set ::AIDA::FEE64 [first $::AIDA::ModuleMenu]}

    proc ReadAIDARegister {Addr}  {
        global errorCode errorInfo
        global MIDAS_XAIDAAccessServer_Exists
        global XAIDAAccessServerHost

# puts "Get Addr=[format \"0x%x\" $Addr]"
# return 0

        if {[info exists MIDAS_XAIDAAccessServer_Exists]} {
# puts "ReadAIDARegister do_Get"
            set rc [catch {interp eval "" ::namespace inscope ::urn:XAIDAAccessServer do_Get $Addr} m]
        } else {
            if {$XAIDAAccessServerHost != $::AIDA::FEE64} {
                set XAIDAAccessServerHost  $::AIDA::FEE64
# puts "ReadAIDARegister configure $XAIDAAccessServerHost"
                XAIDAAccessClient_Configure
            }
# puts "ReadAIDARegister  $XAIDAAccessServerHost  XAIDAAccessClient__Get"
            set rc [catch {XAIDAAccessClient__Get $Addr} m]
        }
        if {$rc != 0} {
#            InsertLog "Get returned with an error\n$m\n$errorCode\n$errorInfo"
  puts "ReadAIDARegister returned with an error\n$m\n$errorCode\n$errorInfo"
            return -1
        } else {
#            InsertLog "Get Addr=[format \"0x%x\" $Addr] => $m [format \"0x%x\" $m]"
#  puts "Get Addr=[format \"0x%x\" $Addr] => $m [format \"0x%x\" $m]"
            return $m
        }
    }

    proc WriteAIDARegister {Addr Vl}  {
        global errorCode errorInfo
        global MIDAS_XAIDAAccessServer_Exists
        global XAIDAAccessServerHost

# puts "Set $Vl => Addr=[format \"0x%x\" $Addr] => $m [format \"0x%x\" $m]"
# return 0

        if {[info exists MIDAS_XAIDAAccessServer_Exists]} {
# puts "WriteAIDARegister do_Set"
            set rc [catch {interp eval "" ::namespace inscope ::urn:XAIDAAccessServer do_Set $Addr $Vl} m]
        } else {
            if {$XAIDAAccessServerHost != $::AIDA::FEE64} {
                set XAIDAAccessServerHost  $::AIDA::FEE64
# puts "WriteAIDARegister configure $XAIDAAccessServerHost"
                XAIDAAccessClient_Configure
            }
# puts "WriteAIDARegister XAIDAAccessClient__Set"
            set rc [catch {XAIDAAccessClient__Set $Addr $Vl} m]
        }
        if {$rc != 0} {
#            InsertLog "Set returned with an error\n$m\n$errorCode\n$errorInfo"
           puts "WriteAIDARegister returned with an error\n$m\n$errorCode\n$errorInfo"
            return -1
        } else {
#            InsertLog "Set $Vl => Addr=[format \"0x%x\" $Addr] => $m [format \"0x%x\" $m]"
#            puts "Set $Vl => Addr=[format \"0x%x\" $Addr] => $m [format \"0x%x\" $m]"
            return $m
        }
    }

    proc ReadAD9252Register {C Addr}  {
        global errorCode errorInfo
        global MIDAS_XAD9252AccessServer_Exists
        global XAD9252AccessServerHost

# puts "Get Addr=[format \"0x%x\" $Addr]"
# return 0

        if {[info exists MIDAS_XAD9252AccessServer_Exists]} {
            set rc [catch {interp eval "" ::namespace inscope ::urn:XAD9252AccessServer do_Get $C $Addr} m]
        } else {
            if {$XAD9252AccessServerHost != $::AIDA::FEE64} {
                set XAD9252AccessServerHost  $::AIDA::FEE64
                XAD9252AccessClient_Configure
            }
            set rc [catch {XAD9252AccessClient__Get $C $Addr} m]
        }
        if {$rc != 0} {
            InsertLog "Get returned with an error\n$m\n$errorCode\n$errorInfo"
            return -1
        } else {
#            InsertLog "Get Addr=[format \"0x%x\" $Addr] => $m [format \"0x%x\" $m]"
            return $m
        }
    }

    proc WriteAD9252Register {C Addr Vl}  {
        global errorCode errorInfo
        global MIDAS_XAD9252AccessServer_Exists
        global XAD9252AccessServerHost

# puts "Set $Vl => Addr=[format \"0x%x\" $Addr] => $m [format \"0x%x\" $m]"
# return 0

        if {[info exists MIDAS_XAD9252AccessServer_Exists]} {
            set rc [catch {interp eval "" ::namespace inscope ::urn:XAD9252AccessServer do_Set $C $Addr $Vl} m]
        } else {
            if {$XAD9252AccessServerHost != $::AIDA::FEE64} {
                set XAD9252AccessServerHost  $::AIDA::FEE64
                XAD9252AccessClient_Configure
            }
            set rc [catch {XAD9252AccessClient__Set $C $Addr $Vl} m]
        }
        if {$rc != 0} {
            InsertLog "Get returned with an error\n$m\n$errorCode\n$errorInfo"
            return -1
        } else {
#            InsertLog "Set $Vl => Addr=[format \"0x%x\" $Addr] => $m [format \"0x%x\" $m]"
            return $m
        }
    }

 proc DBSetValue {name value} {
       variable LogFlag
       global errorCode errorInfo
       global MIDAS_DataBaseCode

       set Project $::DataAcquisition::PROJECT
       set Path [set ::[set Project]::DBRootName]/[set ::[set Project]::DBNodeBase]/[set ::[set Project]::DBNodeName]

        set rc [catch {interp eval "" ::namespace inscope ::urn:DataBaseAccessServer do_set $Path $name $value int} m]
        if {$rc != 0} {
            InsertLog "set returned with an error\n$m\n$errorCode\n$errorInfo"
        } else {
            if {$MIDAS_DataBaseCode == 0} then {
                if {$name == "NULL"} then {
                    InsertLog "$Path created"
                } else {
                    if {$LogFlag == 1} {InsertLog "$Path: $name set to $value"}
                }
            } else {
                set rc [catch {interp eval "" ::namespace inscope ::urn:DataBaseAccessServer do_GetLastError} m]
                InsertLog "$Path $name NOT set: error [second $m]; [third $m]"
            }
        }
  }

 proc DBGetValue {name} {
       variable LogFlag
       global errorCode errorInfo
       global MIDAS_DataBaseCode

       set Project $::DataAcquisition::PROJECT
       set Path [set ::[set Project]::DBRootName]/[set ::[set Project]::DBNodeBase]/[set ::[set Project]::DBNodeName]

        set rc [catch {interp eval "" ::namespace inscope ::urn:DataBaseAccessServer do_get $Path $name} m]
        if {$rc != 0} {
            InsertLog "set returned with an error\n$m\n$errorCode\n$errorInfo"
            set value "Error!"
        } else {
            if {$MIDAS_DataBaseCode == 0} then {
                if {$LogFlag == 1} {InsertLog "$Path: $name = $m"}
                set value "$m"
            } else {
                set rc [catch {interp eval "" ::namespace inscope ::urn:DataBaseAccessServer do_GetLastError} m]
                InsertLog "$Path $name NOT available: error [second $m]; [third $m]"
                set value "Error!"
            }
        }
        return $value
  }

  proc DBCreateNode {Path} {
       variable LogFlag
       global errorCode errorInfo
       global MIDAS_DataBaseCode

        set rc [catch {interp eval "" ::namespace inscope ::urn:DataBaseAccessServer do_set $Path NULL NULL NULL} m]
        if {$rc != 0} {
            InsertLog "set returned with an error\n$m\n$errorCode\n$errorInfo"
        } else {
            if {$MIDAS_DataBaseCode == 0} then {
               InsertLog "$Path created"
            } else {
                set rc [catch {interp eval "" ::namespace inscope ::urn:DataBaseAccessServer do_GetLastError} m]
                InsertLog "$Path NOT created: error [second $m]; [third $m]"
            }
        }
  }

    proc DBGetNodes {Path Pattern} {
       variable LogFlag
        global errorCode errorInfo
        global MIDAS_DataBaseCode


        set nodeList {}

        set rc [catch {interp eval "" ::namespace inscope ::urn:DataBaseAccessServer do_nodes $Path $Pattern} m]
        if {$rc != 0} {
            InsertLog "nodes returned with an error\n$m\n$errorCode\n$errorInfo"
        } else {
            if {$MIDAS_DataBaseCode >= 0} then {
                if {$MIDAS_DataBaseCode == 0} then {
                     if {$LogFlag == 1} {InsertLog "$Path contains nodes"}
                     set nodeList {}
                     foreach item $m {
                         lappend nodeList $item
                         if {$LogFlag == 1} {InsertLog "$item"}
                     }
                } else {
                     if {$LogFlag == 1} {InsertLog "$Path contains no nodes"}
                }
            } else {
                set rc [catch {interp eval "" ::namespace inscope ::urn:DataBaseAccessServer do_GetLastError} m]
                InsertLog "$Path access error: error [second $m]; [third $m]"
            }
        }
        return $nodeList
    }

   proc update_Options {} {
      global Options

     set BAK [set ::[set ::DataAcquisition::PROJECT]::DBNodeBase]

      set ::[set ::DataAcquisition::PROJECT]::DBNodeBase Options

      set OptionList ""
      foreach item [array names Options] {
         if {$item == "Index"} {continue}
         if {[string length $OptionList] > 0} {append OptionList "&&"}
         append OptionList "$item"
         DBSetValue $item $Options($item)
      }
      DBSetValue Index $OptionList

      set ::[set ::DataAcquisition::PROJECT]::DBNodeBase $BAK
   }

   proc load_Options {} {
      global Options 

     set BAK ::[set [set ::DataAcquisition::PROJECT]::DBNodeBase]

      set ::[set ::DataAcquisition::PROJECT]::DBNodeBase Options

      foreach item [split [DBGetValue Index] &&] {
         if {$item == "Index"} {continue}
         if {$item == ""} {continue}
         set Options($item) [DBGetValue $item]
      }

      set ::[set ::DataAcquisition::PROJECT]::DBNodeBase $BAK
   }


