
#    Note:  This is loaded into the namespace  AIDA_Diagnostics

#variable started 0

if {![info exists started]} {variable started 0}

if {$started != 0} {

    variable JS ""
    variable LogFlag

   if {$LogFlag == 1} {InsertLog "Last Updated: [clock format [clock seconds] -format "%B %d, %Y %H:%M:%S"]"}

    do_click

}

if {$started == 0} {
    set started 1

    variable ShowLogFlag 0

    variable LogText ""
    variable LogFlag 0
    variable LogCount 0

    variable JS ""

    variable AddrSpaceList

    variable Offset0x000
    variable Offset0x200
    variable Offset0x300
    variable Offset0x310
    variable Offset0x400
    variable Offset0x410
    variable Offset0x500
    variable Offset0x600
    variable Offset0x4000
    variable Offset0x8000
    variable Offset0xa000
    variable Offset0x40000

    variable AddrSpace
    variable Address
    variable Offset
    variable SData
    variable GData


     set AddrSpaceList [list \
         "Local Control: 0x000" \
         "Temperature: 0x200" \
         "ASIC Readout - Buffer and Control: 0x300" \
         "MBS I/F: 0x310" \
         "Timestamp Control: 0x400" \
         "Master Timestamp Counter Control: 0x410" \
         "Discriminator Control: 0x500" \
         "ASIC Readout - DMA control and status: 0x600"  \
         "ASIC1 Controls: 0x4000" \
         "ASIC2 Controls: 0x4040" \
         "ASIC3 Controls: 0x4080" \
         "ASIC4 Controls: 0x40c0" \
         "ASIC Readout Buffer: 0x8000" \
         "Preamp ADC: 0x40000"  \
    ]

    set Offset0x000 [list \
        "Control:  0x00"  \
        "Status:  0x01"  \
        "ADC Control:  0x02"  \
        "Trigger O/P Control:  0x03"  \
        "Pulser rate:  0x04"   \
        "LMK03200 control:  0x05"  \
        "Trigger delay:  0x06"   \
        "BuTiS i/f control:  0x07"  \
        "SYNC control:  0x08"  \
    ]

    set Offset0x200 [list \
        "Start0:  0x00"  \
        "Value0:  0x01"  \
        "Start1:  0x02"  \
        "Value1:  0x03"  \
        "Start2:  0x04"   \
        "Value2:  0x05"  \
        "Status:  0x08"   \
    ]

    set Offset0x300 [list \
        "Control:  0x00"  \
        "Status:  0x02"  \
        "Multiplicity:  0x03"  \
        "Event Count low:  0x04"  \
        "Event Count high:  0x05"   \
        "ASIC resets:  0x06"  \
        "ASIC readout enable:  0x07"   \
        "Waiting count:  0x0c"   \
        "Convert delay:  0x0d"   \
        "events pending:  0x0e"   \
    ]

    set Offset0x310 [list \
        "Control:  0x00"  \
        "Status:  0x02"  \
        "Scaler LSW:  0x03"  \
        "Scaler MSW:  0x04"  \
        "Trigger delay:  0x05"   \
        "Force trigger:  0x06"  \
    ]

    set Offset0x400 [list \
        "Control:  0x00"  \
        "Status:  0x01"  \
        "Timestamp readback LSW:  0x04"  \
        "Timestamp readback MSW:  0x05"   \
        "SYNC value:  0x06"  \
        "Timestamp load LSW:  0x08"   \
        "Timestamp load MSW:  0x09"   \
        "ReSYNC value LSW:  0x0a"   \
        "ReSYNC value MSW:  0x0b"   \
    ]

    set Offset0x410 [list \
        "Control:  0x00"  \
        "Status:  0x01"  \
        "Timestamp readback LSW:  0x02"  \
        "Timestamp readback MSW:  0x03"   \
        "SYNC value:  0x04"  \
        "Timestamp load LSW:  0x05"   \
        "Timestamp load MSW:  0x06"   \
        "ReSYNC value LSW:  0x07"   \
        "ReSYNC value MSW:  0x08"   \
    ]

    set Offset0x500 [list \
        "Control:  0x00"  \
        "Status:  0x02"  \
        "Channel disable pattern LSW:  0x06"  \
        "Channel disable pattern MSW:  0x07"   \
        "ASIC1 discriminator value:  0x08"  \
        "ASIC2 discriminator value:  0x09"  \
        "ASIC3 discriminator value:  0x0a"  \
        "ASIC4 discriminator value:  0x0b"  \
    ]

    set Offset0x600 [list \
        "Control:  0x00"  \
        "State Machine:  0x01" \
        "Status:  0x02"  \
        "DMA buffer Start Address:  0x03"  \
        "DMA block High Water Mark:  0x04"   \
        "Low Block item counter:  0x05"  \
        "High Block item counter:  0x06" \
        "Flush:  0x07"  \
        "Test Counter:  0x08"  \
        "Buffer Size:  0x09"  \
        "Source Select:  0x0a"  \
        "Low Block taken:  0x0b"  \
        "High Block taken:  0x0c"  \
    ]

    set Offset0x4000 [list \
        0 1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 \
        20 21 22 23 24 25 26 27 28 29  \
    ]

    set Offset0x4040 [list \
        0 1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 \
        20 21 22 23 24 25 26 27 28 29  \
    ]

    set Offset0x4080 [list \
        0 1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 \
        20 21 22 23 24 25 26 27 28 29  \
    ]

    set Offset0x40c0 [list \
        0 1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 \
        20 21 22 23 24 25 26 27 28 29  \
    ]

    set Offset0x8000 [list 0 1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19]

    set Offset0x40000 [list \
        "Control:  0x00"  \
        "Status:  0x01"  \
        "Acquisition enable:  0x02"  \
        "Acquisition reset:  0x03"   \
        "Acquisition triggered:  0x04"  \
        "Post trigger:  0x05"   \
        "Calibrate feedback Ch1:  0x08"   \
        "Calibrate feedback Ch2:  0x09"   \
        "Calibrate feedback Ch3:  0x0a"   \
        "Calibrate feedback Ch4:  0x0b"   \
        "Calibrate feedback Ch5:  0x0c"   \
        "Calibrate feedback Ch6:  0x0d"   \
        "Calibrate feedback Ch7:  0x0e"   \
        "Calibrate feedback Ch8:  0x0f"   \
    ]


    set Address 0x0000
    set AddrSpace [lindex $AddrSpaceList 0]
    set Offset 0
    set SData            0x0000
    set GData            ******

   proc  show_variables {} {
        variable AddrSpace
        variable Address
        variable Offset
        variable SData
        variable GData

        InsertLog "FEE64 = $::AIDA::FEE64"
        InsertLog "AddrSpace=$AddrSpace; Address=$Address; Offset=$Offset; SetData=$SData; GetData=$GData"
   }



   proc  do_click {}  {
       variable cgidata
       variable started
       variable LogText
       variable ShowLogFlag
       variable LogFlag
       variable Address
       variable AddrSpace
       variable Offset
       variable SData
       variable GData

       set cgidata [ncgi::nvlist]

       if {$LogFlag == 1} {InsertLog "cgidata= ([llength $cgidata]) $cgidata"}

       if {[llength $cgidata] == 0} then {return}

       if {[llength $cgidata] < 2} then {
          InsertLog "CGI data is too short: $cgDiagnostics.tmlidata"
       } else {
          if {[lindex $cgidata 0] != "Widget"} then {
             InsertLog "Invalid CGI data: $cgidata"
          } else {

              set w [first [lindex $cgidata 1]]
              set vl [second [lindex $cgidata 1]]

            switch -glob $w {

                RESET    {set started 0}
                   CLEAR    {EmptyLog}
                   ELOG     {PrintLog}
                SELECT   {}
                RELOAD   {}
                VARIABLES {show_variables}

                HIDE     {set ShowLogFlag 0}
                SHOW     {set ShowLogFlag 1}
                   LOGON    {set LogFlag 1}
                   LOGOFF   {set LogFlag 0}

                SET      {WriteAIDARegister [expr $Address + $Offset] $SData}
                GET      {set GData [ReadAIDARegister [expr $Address + $Offset]]}
                SETGET   {
                    WriteAIDARegister [expr $Address + $Offset] $SData
                    set GData [ReadAIDARegister [expr $Address + $Offset]]
                }

                ADDRSPACE  {
                    set Address [last [lindex $cgidata 1]]
                    set AddrSpace "[lreplace [lindex $cgidata 1] 0 0]"
                    set Offset 0
                }
                OFFSET     {set Offset [last [lindex $cgidata 1]]}
                SDATA      {set SData  [last [lindex $cgidata 1]]}

                MODULE     {set ::AIDA::FEE64 $vl}

                MainLog {}
                undefined {}
                default {InsertLog "unexpected CGI data:  $cgidata"}
            }
         }
      }
   }

}   ;# end of if {$started == 0} 

